%function hmm=setStationary(hmm);
%set initial state probability = stationary state probability
%for a HMM object or multidim array of HMM objects
%
%Input:
%hmm=     single HMM object or multidim array of HMM objects
%
%Result:
%hmm=   HMM object(s) with all MarkovChains forced stationary
%
%Arne Leijon 2009-07-23 tested

function hmm=setStationary(hmm)
nObj=numel(hmm);
for i=1:nObj%for all of them
    hmm(i).StateGen=setStationary(hmm(i).StateGen);%just dispatch to sub-object
end;