function avi=testVQmovie(nC,aviname)
%Create movie to illustrate VQ training
%Input:
%mC=    wanted codebook size
%aviname= string with avi file name for output
%
%Arne Leijon 2010-11-19 tested

X=randn(2,50000);%training data
vq=init(VQ,X,nC);
avi=avifilehandle(aviname);
avi.fps=3;
avi.videoname='VQ training';
avi.compression='None';

plotFig=figure(1);
%set(plotFig,'renderer','opengl');%seems necessary, although aviframe should do it...???
addVQframe(vq,X,avi,plotFig);%add first frame to result movie
fun=@(v)addVQframe(v,X,avi,plotFig);

vq=trainLloyd(vq,X, @(v)addVQframe(v,X,avi,plotFig));
avi.close;

%------- frame-plot subfunction
    function addVQframe(vq,X,avifileH,figH)
        figure(figH);
        plot(X(1,:),X(2,:),'.b');%plot training data
        hold on;
        cX=vq.CodeBook;
        voronoi(cX(1,:),cX(2,:),'r');%plot Voronoi regions
        plot(cX(1,:),cX(2,:),'or');%plot code points
        hold off;
        axis([-3 3 -3 3]);
        axis square;
        title('VQ training');
        %pause;
        avifileH.addframe(figH);%save it to the movie
    end
end