% Gustav Eje Henter 2012-11-15

function pD = adaptSet(pD,aState)

for i = 1:numel(pD),
    if (aState(i).sumGamma > 0),
        pD(i) = setSingle(pD(i),aState(i));
    end
end

function pD = setSingle(pD,aState)

D = pD.DataSize;
o = pD.Order;

pD.AllowCorr = false;

G = aState.sumGamma;

pD.Mean = aState.sumX/G;
r0 = aState.sumXX/G - pD.Mean.*pD.Mean;

if (o <= 0),
    pD.StDev = sqrt(r0);
else
    pD.SummMean = aState.sumSumm/G;
    
    rd = aState.sumXSumm/G - pD.SummMean.*repmat(pD.Mean,1,o);
    
    for d = 1:D,
        Rmat = aState.sumSummSumm(:,:,d)/G...
            - pD.SummMean(d,:)'*pD.SummMean(d,:);
        pD.ARCoeff(d,1:o) = rd(d,:)/Rmat;
    end
    
    pD.StDev = sqrt(r0 - sum(pD.ARCoeff.*rd,2));
end

if ~all(pD.StDev > 0),
    pD.StDev = Inf*ones(size(pD.Mean));
end