% Gustav Eje Henter 2012-11-15

function [pD,iOK] = init(pD,xs,lxs)

[D Nx] = size(xs);

if (nargin < 3) || isempty(lxs),
    lxs = Nx;
end

o = max([pD(:).Order]);
R = numel(lxs);

lis = max(0,lxs-o);
Ni = sum(lis);

cxs = [0 cumsum(lxs)];
cis = [0 cumsum(lis)];

% Create x-supervector for initialization
xinit = zeros(D*(o+1),Ni);
for r = 1:R,
    if (lis(r) <= 0),
        continue;
    end
    for l = 0:o,
        xinit(D*l+(1:D),cis(r)+1:cis(r+1))...
            = xs(:,cxs(r)+1+l:cxs(r+1)-o+l);
    end
end

nObj = numel(pD);
iOK = zeros(size(pD));

if nObj > Ni,
    error('Too few data vectors');
end
%if Ni <= 1, %var cannot be estimated
%    warning('GaussAR:Init:TooFewData','Only one data point: default variance =1');
%    varX=ones(D,1);%default variance =1
%    iOK(1) = 0;%variance incorrect
%else
%    varX = var(xinit(D*o+(1:D),:),1,2);%ML (biased) estim var of all observed data
%    iOK(1) = 1;%OK
%end
if (nObj > 1),
    %Use VQ methods
    %although first test with VQ method locked on a local maximum.
    xVQ = create(VQ,xinit,nObj);%make VQ
    %xCenters = xVQ.CodeBook;%VQ centroids
    xCode = encode(xVQ,xinit);%nearest codebook index for each vector
    rhos = (repmat((1:nObj)',1,Ni) == repmat(xCode,nObj,1));
else
    rhos = ones(1,Ni);
    %pD.Mean = mean(xinit(D*o+(1:D),:),2);
    %pD.Variance = varX;%set variance
    %pD.
end

[pD(:).Mean] = deal(zeros(D,1));
aState = adaptStart(pD);
for r = 1:R,
    if (lis(r) <= 0),
        continue;
    end
    aState = adaptAccum(pD,aState,xs(:,cxs(r)+1:cxs(r+1)),...
        rhos(:,cis(r)+1:cis(r+1)));
end
pD = adaptSet(pD,aState);