% Gustav Eje Henter 2013-12-15

function [lpzs,logS] = logprob(k,x1,x2)

D = size(x1,1);

taus = k.Taus(k.Tied);

if (nargin < 3) || isempty(x2),
    x2 = x1;
end

tmat = spdiags(taus,0,D,D);
d2s = sqdistance(x1,x2,tmat);

lpzs = (sum(log(taus)) - D*log(2*pi) - d2s)/2;

if (nargout > 1),
    logS = max(lpzs,[],1);
    lpzs = lpzs - repmat(logS,size(lpzs,1),1);
end