% Gustav Eje Henter 2013-02-15

function [lpzs,logS] = marginalLogprob(k,x1,x2,givenDims)

D = k.DataSize;

taus = k.Taus(k.Tied);

if (nargin < 3) || isempty(x2),
    x2 = x1;
end

if (nargin < 4) || isempty(givenDims),
    N1 = size(x1,2); % Assume the unconditional case
    N2 = size(x2,2);
    lpzs = zeros(N1,N2);
    logS = zeros(1,N2);
    return;
end

% Prune irrelevant dimensions -- those we are marginalizing out
if (size(x1,1) == D),
    x1 = x1(givenDims,:);
end
if (size(x2,1) == D),
    x2 = x2(givenDims,:);
end
taus = taus(givenDims,:);

D = size(x1,1); % New, reduced dimensionality

tmat = spdiags(taus,0,D,D);
d2s = sqdistance(x1,x2,tmat);

lpzs = (sum(log(taus)) - D*log(2*pi) - d2s)/2;

if (nargout > 1),
    logS = max(lpzs,[],1);
    lpzs = lpzs - repmat(logS,size(lpzs,1),1);
end