% Gustav Eje Henter 2013-02-16

function k = init(k,xs,ws)

[D,N] = size(xs);

if (nargin < 3) || isempty(ws),
    ws = ones(1,N);
else
    ws = max(ws,0);
end

W = sum(ws);
ws = ws/W;

M = xs*ws';
residuals = xs - repmat(M,1,N);

protoV = (residuals.^2)*ws';

exponent = 2*k.binRatio/(D+k.binRatio);

if numel(k.Tied) ~= D,
    k.Tied = ones(D,1); % Isotropic kernel by default
    %k.Tied = (1:D)'; % No dimensional tying by default
end

% This bandwidth selection heuristic can probably be improved
k.Taus = zeros(max(k.Tied),1);
for i = 1:numel(k.Taus),
    k.Taus(i) = (N.^exponent)./mean(protoV(k.Tied == i));
end