% Gustav Eje Henter 2013-04-10

function [X,S] = conditionalRand(h,x0,nSamples,s0prob)

if (numel(h) > 1),
    error('Method works only for a single object');
end

if (nargin < 3),
    nSamples = 1;
end

%n0 = size(x0,2);

mc = h.StateGen;

% Force starting state probabilities, if given
if (nargin > 3) && all(size(s0prob) == size(mc.InitialProb)),
    s0prob = max(s0prob,0);
    if (sum(s0prob) > 0),
        mc.InitialProb = s0prob/sum(s0prob);
    end
end

S = rand(mc,nSamples);
nS = length(S);

%D = h.DataSize;
X = x0;
tstart = 1;
while tstart <= nS,
    s = S(tstart);
    
    for tend = tstart+1:nS,
        if (S(tend) ~= s),
            tend = tend-1;
            break;
        end
    end
    if isempty(tend),
        tend = tstart;
    end
    
    %X(:,1:n0+tend)...
    %    = h.OutputDistr(s).conditionalRand(X(:,1:n0+tstart-1),tend-tstart+1);
    X = h.OutputDistr(s).conditionalRand(X,tend-tstart+1);
    tstart = tend+1;
end