% Gustav Eje Henter 2013-02-04

function [lp,lrhos] = conditionalLogprob(mm,xs,x0)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation, regardless of x0
    Nx = pD(1).NumPoints; % We assume all pD have the same number of points
else
    Nx = size(xs,2);
end

nD = numel(mm);

lp = zeros(nD,Nx);
lrhos = cell(nD,1);

if (nargin < 3) || isempty(x0),
    [lp,lrhos] = logprob(mm,xs); % Assume the unconditional case
else
    for i = 1:nD,
        [lp(i,:),lrhos{i}] = singleConditionalLogprob(mm(i),xs,x0);
    end
end

if (nD == 1) && iscell(lrhos),
    lrhos = lrhos{1};
end