% Gustav Eje Henter 2012-02-05

function [xs,zs] = rand(mm,nSamples)

if (numel(mm) ~= 1),
    error('This function only works for a single object!');
end

if (nargin < 2) || isempty(nSamples),
    nSamples = 1;
end

o = mm.Order;

if (o <= 0),
    [xs,zs] = rand@KernelDensity(mm,nSamples); % IID rand
    return;
end

zs = zeros(1,max(nSamples-o,1));
xs = zeros(1,nSamples);

if ~mm.Stationary,
    warning('KDEMM:ApproximateInitialization',...
        'Nonstationary initialization is only approximately correct');
end

[pts,zs(1)] = rand@KernelDensity(mm,1);

xs(:,1:o+1) = mm.points2series(pts,true);

if (nSamples < o+1),
    xs = xs(:,1:nSamples);
elseif (nSamples > o+1)
    [xs,zs(2:end)] = conditionalRand(mm,xs(:,1:o+1),nSamples-o-1);
end