% Gustav Eje Henter 2012-11-30

function mm = adaptSet(mm,aState)

for i = 1:numel(mm),
    if (aState(i).sumGamma > 0),
        mm(i) = setSingle(mm(i),aState(i));
    end
end

function mm = setSingle(mm,aState)

o = mm.Order;

mm.Kern.Taus(o+1) = aState.sumGamma/aState.sumSqrDev;

maxIter = 10;

% Multidimensional optimization
opts = optimset(@fminunc);
opts.MaxIter = maxIter;
opts.MaxFunEvals = [num2str(max(100,maxIter)) '*numberofvariables'];
opts.Display = 'off';

%[logtaus,lpopt,exitflag] =...
%    fminunc(@(lt) (-auxiliaryFunc(mm,aState,exp(lt))),...
%    log(mm.Kern.Taus(1:o)),opts);
%
%mm.Kern.Taus(1:o) = exp(logtaus);

function Qval = auxiliaryFunc(mm,aState,taus)

%o = mm.Order;
R = numel(aState.lxs);

taus = [taus;mm.Kern.Taus(end)];

cxs = [0 cumsum(aState.lxs)];
Qval = 0;
for r = 1:R,
    x = aState.xs(:,cxs(r)+1:cxs(r+1));
    gamma = aState.gammas{r};
    gmrhos = aState.gmrhos{r};
    
    %T = size(x,2);
    
    % Compute responsibilities
    if mm.Crossval,
        [~,~,rhos] = mm.prob([],taus);
        
        %xseg = zeros(o+1,T-o);
        %for l = 1:o+1,
        %    xseg(l,:) = x(l:end-o-1+l);
        %end
    else
        [~,~,rhos] = mm.prob(x,taus);
        
        %xseg = mm.Points;
    end
    
    logrhos = log(rhos);
    logrhos(gmrhos == 0) = 0;
    Qval = Qval + sum(logrhos.*gmrhos,1)*gamma';
end

Qval = Qval/aState.sumGamma;