% Gustav Eje Henter 2012-11-28

function [xs,zs] = conditionalRand(mm,x0,nSamples,bwparms)

if (numel(mm) ~= 1),
    error('This function only works for a single object!');
end

if (nargin < 3) || isempty(nSamples),
    nSamples = 1;
end

if (nargin < 4),
    bwparms = [];
end

if (nargin < 2) || isempty(x0),
    if ~mm.Stationary,
        warning('KDEMM:IncorrectInitialization',...
            'Initialization is not implemented exactly correct');
    end
    [xs,zs] = rand(mm,nSamples,bwparms); % Assume the unconditional case
    return;
end

o = mm.Order;
N0 = size(x0,2);

zs = zeros(1,nSamples);
xs = zeros(1,N0+nSamples);

xs(1:N0) = x0;

for t = 1:nSamples,
    [xs(t+N0),zs(t)] = conditionalRand@KernelDensity(mm,xs(t+N0-o:t+N0-1)',...
        [true(o,1);false],bwparms);
end