% Gustav Eje Henter 2012-11-28

function [p,logS,rhos] = singleConditionalProb(mm,xs,x0,bwparms)

o = mm.Order;
N = mm.NumPoints;

N0 = size(x0,2);
givenDims = 1:o;

if isempty(xs),
    % Use self-log-prob with cross-validation, regardless of x0
    [p,logS,rhos]...
        = singleConditionalProb@KernelDensity(mm,[],givenDims,bwparms);
    
    if mm.Stationary,
        % Remove values due to periodic extension
        p = p(1:end-o);
        rhos = rhos(:,1:end-o);
        logS = logS(1:end-o);
    end
elseif (N0 >= o),
    
    Nx = size(xs,2);
    xs = [x0(end-o+1:end) xs];
    
    xsegs = zeros(o+1,Nx);
    for p = 1:o+1,
        xsegs(p,:) = xs(p:(p+Nx-1));
    end
    
    [p,logS,rhos]...
        = singleConditionalProb@KernelDensity(mm,xsegs,givenDims,bwparms);
else
    % Not enough data to compute a value
    p = [];
    rhos = zeros(N,0);
    logS = [];
end