% Gustav Eje Henter 2013-02-01

function [lp,lrhos] = conditionalLogprob(pD,xs,givenDims)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
    Nx = pD(1).NumPoints; % We assume all pD have the same number of points
else
    Nx = size(xs,2);
end

nD = numel(pD);

lp = zeros(nD,Nx);
lrhos = cell(nD,1);

if (nargin < 3) || isempty(givenDims),
    [lp,lrhos] = logprob(pD,xs); % Assume the unconditional case
else
    for i = 1:nD,
        [lp(i,:),lrhos{i}] = singleConditionalLogprob(pD(i),xs,givenDims);
    end
end

if (nD == 1) && iscell(lrhos),
    lrhos = lrhos{1};
end