% Gustav Eje Henter 2013-01-31

function [lp,lrhos] = marginalLogprob(pD,xs,givenDims)

if (nargin < 2) || isempty(xs),
    xs = []; % Use self-logprob with cross-validation
    Nx = pD(1).NumPoints; % We assume all pD have the same number of points
else
    Nx = size(xs,2);
end

nD = numel(pD);

lp = zeros(nD,Nx);
lrhos = cell(nD,1);

if (nargin < 3) || isempty(givenDims),
    %lp = zeros(nD,Nx); % Assume the unconditional case
    for i = 1:nD,
        lrhos{i} = repmat(log(pD(i).Weights),1,Nx);
    end
else
    for i = 1:nD,
        [lp(i,:),lrhos{i}] = singleMarginalLogprob(pD(i),xs,givenDims);
    end
end

if (nD == 1) && iscell(lrhos),
    lrhos = lrhos{1};
end