% Gustav Eje Henter 2012-11-12

function [p,rhos,logS] = prob(pD,xs,bwparms)

N = pD.NumPoints;

if (nargin < 3),
    bwparms = [];
end

crossval = false;
if (nargin < 2) || isempty(xs),
    % Self-log-prob with cross-validation
    xs = [];
    crossval = true;
end

[lpzs,logS] = pD.Kern.logprob(pD.Points,xs,bwparms);

Nx = size(lpzs,2);

% Incorporate component weights

%lpzs = lpzs + repmat(log(pD.Weights'),1,Nx);

wm = repmat(pD.Weights',1,Nx);
if crossval,
    wm = wm./repmat(1 - wm(1:N+1:N*N),N,1);
    wm(1:N+1:N*N) = 0;
end
lpzs = lpzs + log(wm);

% Recompute logS
logS2 = max(lpzs,[],1);
lpzs = lpzs - repmat(logS2,N,1);
logS = logS + logS2;

if (nargout > 1),
    rhos = exp(lpzs);
    rhos = rhos./repmat(sum(rhos,1),N,1);
end

if (nargout > 2),
    p = sum(exp(lpzs),1);
else
    p = sum(exp(lpzs),1).*exp(logS);
end