% Gustav Eje Henter 2012-11-02

function [pD,logprobs] = train(pD,maxIter)

[D N] = size(pD.Points);

logprobs(1) = sum(pD.logprob)/(D*N);

if pD.Kern.Isotropic || (D == 1),
    % One-dimensional optimization
    opts = optimset(@fminsearch);
    opts.MaxIter = maxIter;
    opts.MaxFunEvals = [num2str(max(200,maxIter)) '*numberofvariables'];
    
    [logtau,lpopt,exitflag] =...
        fminsearch(@(lt) (-sum(pD.logprob([],exp(lt)))/(D*N)),...
        log(pD.Kern.Taus(1)),opts);
    
    pD.Kern.Taus = exp(logtau)*ones(D,1);
else
    % Multidimensional optimization
    opts = optimset(@fminunc);
    opts.MaxIter = maxIter;
    opts.MaxFunEvals = [num2str(max(100,maxIter)) '*numberofvariables'];
    opts.Display = 'off';
    
    [logtaus,lpopt,exitflag] =...
        fminunc(@(lt) (-sum(pD.logprob([],exp(lt)))/(D*N)),...
        log(pD.Kern.Taus),opts);
    
    pD.Kern.Taus = exp(logtaus);
end

logprobs(2) = sum(pD.logprob)/(D*N);

%function lp = logprobOfLogTau(pD,logtau)
%
%[D N] = size(pD.Points);
%
%pD.Kern.Taus = exp(logtau)*ones(D,1);
%
%lp = sum(pD.logprob)/(D*N);