% Gustav Eje Henter 2012-11-28

function [p,logS,rhos] = singleConditionalProb(pD,xs,givenDims,bwparms)

crossval = false;
if isempty(xs),
    crossval = true;
end

[lpjoint,logSjoint] = pD.Kern.logprob(pD.Points,xs,bwparms);
[lpmarg,logSmarg] = pD.Kern.marginalLogprob(pD.Points,xs,givenDims,bwparms);

%[lpzs,logS] = pD.Kern.conditionalLogprob(pD.Points,xs,givenDims,bwparms);

N = pD.NumPoints;
Nx = size(lpjoint,2);

% Incorporate component weights
wm = repmat(pD.Weights',1,Nx);
if crossval,
    wm = wm./repmat(1 - wm(1:N+1:N*N),N,1);
    wm(1:N+1:N*N) = 0;
end
logwm = log(wm);

lpjoint = lpjoint + logwm;
lpmarg = lpmarg + logwm;

% Recompute logS
logStmp = max(lpjoint,[],1);
lpjoint = lpjoint - repmat(logStmp,N,1);
logSjoint = logSjoint + logStmp;

logStmp = max(lpmarg,[],1);
lpmarg = lpmarg - repmat(logStmp,N,1);
logSmarg = logSmarg + logStmp;

logS = logSjoint - logSmarg;

rhos = exp(lpjoint);
rhos = rhos./repmat(sum(rhos,1),N,1);

p = sum(exp(lpjoint),1)./sum(exp(lpmarg),1);