% Gustav Eje Henter 2013-05-29

function gammas = envelopeinit(datastr,ntrain,maxstates,peaksearch,tol)

load([datastr '_data'],'xs');

xs = xs(:,1:ntrain); % Crop out training data

if (nargin < 4) || isempty(peaksearch),
    maxsearch = estimate_discrete_maxima(xs);
    minsearch = estimate_discrete_maxima(-xs);
end

if (nargin < 5) || isempty(tol),
    tol = 0.5;
end

[cmaxima,cmaxvals] = estimate_maxima(xs,maxsearch,tol);
[cminima,cminvals] = estimate_maxima(-xs,minsearch,tol);
cminvals = -cminvals;

maxspline = fake_nat_spline(cmaxima,cmaxvals);
minspline = fake_nat_spline(cminima,cminvals);

envvals = ppval(maxspline,1:ntrain) - ppval(minspline,1:ntrain);

[sortenvs,sortis] = sort(envvals);

qtiles(sortis) = (0.5 + (0:ntrain-1))/ntrain;

gammas = qtile2gamma(qtiles,1:maxstates)';