% Gustav Eje Henter 2013-05-03

function mc = gammas2mc(gammas)

[nS nX] = size(gammas);

% Create an A-matrix that accounts for correlations

Ahat = zeros(nS);

% Count (soft) transitions between responsibilities
Ahat = Ahat + gammas(:,1:end-1)*gammas(:,2:end)';

Ahat = spdiags(1./sum(Ahat,2),0,nS,nS)*Ahat; % Normalize rows

% Find stationary distribution
[q,~] = eigs(Ahat',1,'lm');
q = q/sum(q);

mc = MarkovChain('InitialProb',q,'TransitionProb',Ahat);