% Gustav Eje Henter 2013-05-07

function [rhos,gmd,lps] = gmm_assign(ns,order,xs,miniter,minstep,prepad)

if (nargin < 1) || isempty(ns),
    ns = 1;
end

if (nargin < 2) || isempty(order),
    order = 0;
end

if (nargin < 4) || isempty(miniter),
    miniter = 10;
end

if (nargin < 5) || isempty(minstep),
    minstep = log(1.01);
end

if (nargin < 6) || isempty(prepad),
    prepad = false;
end

Dx = size(xs,1);
pts = make_pts(xs,order);

gs = repmat(GaussD,ns,1);

recreate = true;
while recreate,
    gmd = init(GaussMixD(gs,ones(ns,1)),pts);
    [gmd,lps] = train(gmd,pts,miniter,minstep);
    recreate = (numel(gmd.Gaussians) ~= ns);
end

rhos = gmm_rhos(gmd,pts,Dx*prepad);