% Gustav Eje Henter 2013-06-20

function xs = simple_gmm_ar_rand(transp,arc,sigma,sep,nsamp)

burnin = 200;

totsamp = burnin + nsamp;

mc = MarkovChain('InitialProb',[.5;.5],...
    'TransitionProb',[1-transp,transp;transp,1-transp]);

qs = mc.rand(totsamp);
qs = qs - 1;

xprev = randn(1,1)/(1-arc);
xprev = xprev*(sigma.^qs(1));

noise = randn(1,totsamp) + sep*(2*(rand(1,totsamp) < 0.5) - 1);
noise = noise./sqrt(1 + sep*sep);

noise = noise.*(sigma.^qs);

xs = zeros(1,totsamp);

for t = 1:totsamp,
    xs(t) = arc*xprev + noise(t);
    xprev = xs(t);
end

%% plot(xs);
%% hold on;
%% plot(xs(1:burnin),'r');
%% hold off;

xs = xs(:,end-nsamp+1:end);