% Gustav Eje Henter 2013-06-05

function gammas = stretchinit(datastr,ntrain,maxstates,triggerpts)

load([datastr '_data'],'xs');

xs = xs(:,1:ntrain); % Crop out training data

if (nargin < 4) || isempty(triggerpts),
    triggerpts = estimate_discrete_maxima(xs);
end

ntp = numel(triggerpts);

xds = diff(xs,1,2);
xchng = sqrt(sum(xds.^2,1));

cumchng = cumsum([0 xchng]);

%plot(cumchng,xs);

cumchng0s = cumchng(triggerpts);
cumchngdeltas = diff(cumchng0s);
cumchngdeltas = [cumchngdeltas cumchngdeltas(end)];

tpnum = sum(repmat(triggerpts',1,ntrain) <= repmat(1:ntrain,ntp,1),1);
tpnum(tpnum < 1) = 1;

thetas = (cumchng - cumchng0s(tpnum))./cumchngdeltas(tpnum) + (tpnum-1);
thetas = 2*pi*thetas;

gammas = phase2gamma(thetas,1:maxstates)';

%plot(mod(thetas/2/pi,1),xs,'b-');