% Gustav Eje Henter 2012-04-25

function [qxs,cis] = quantize_array(centers,xs)

if (nargout < 2),
    centers = sort(centers);
    qxs = interp1(centers,centers,xs,'nearest');
    qxs(xs <= centers(1)) = centers(1); % Handle extrapolation
    qxs(xs >= centers(end)) = centers(end);
else
    ncenters = numel(centers);
    nx = numel(xs);
    
    centers = reshape(centers,ncenters,1);
    xs = reshape(xs,1,nx);
    
    [~,cis] = min(abs(xs(ones(1,ncenters),:) - centers(:,ones(1,nx))),[],1);
    qxs = centers(cis);
end